package ch.dlmw.swisssignchallenge.controllers;

import ch.dlmw.swisssignchallenge.services.impl.SigningRequestService;
import lombok.AllArgsConstructor;
import org.openapitools.api.SigningRequestApi;
import org.openapitools.model.GetSigningRequestResponse;
import org.openapitools.model.GetSigningRequestResponseSigningRequestDocument;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

@RestController
@AllArgsConstructor
public class SigningRequestController implements SigningRequestApi {
    private final SigningRequestService signingRequestService;

    public ResponseEntity<GetSigningRequestResponse> getSigningRequest(String id) {
        var signingRequest = signingRequestService.getSigningRequest(id);
        var response = new GetSigningRequestResponse(signingRequest.getId().toString(), signingRequest.isSigned());

        for (var doc : signingRequest.getDocuments()) {
            response.addSigningRequestDocumentsItem(new GetSigningRequestResponseSigningRequestDocument(
                    doc.getId().toString(),
                    doc.getName(),
                    doc.isConfirmed()
            ));
        }

        return ResponseEntity.ok(response);
    }
}
