package ch.dlmw.swisssignchallenge.entities;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;
import java.util.UUID;

@Entity
@Table(name = "signing_request")
@Getter
@Setter
@NoArgsConstructor
public class SigningRequest {
    @Id
    @GeneratedValue(generator = "UUID")
    @Column(name = "id", updatable = false, nullable = false)
    private UUID id;

    @Column(name = "signed", nullable = false)
    private boolean signed;

    @OneToMany(mappedBy = "signingRequest", cascade = CascadeType.ALL, orphanRemoval = true)
    private List<SigningRequestDocument> documents;
}
