package ch.dlmw.swisssignchallenge.entities;

import com.fasterxml.jackson.annotation.JsonIgnore;
import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;

import java.util.UUID;

@Entity
@Table(name = "signing_request_document")
@Getter
@Setter
public class SigningRequestDocument {
    @Id
    @GeneratedValue(generator = "UUID")
    @Column(name = "id", updatable = false, nullable = false)
    private UUID id;

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "signing_request_id", nullable = false)
    @JsonIgnore
    private SigningRequest signingRequest;

    @Column(name = "name", nullable = false)
    private String name;

    @Column(name = "confirmed", nullable = false)
    private boolean confirmed;
}