package ch.dlmw.swisssignchallenge.services.impl;

import ch.dlmw.swisssignchallenge.entities.SigningRequestDocument;
import ch.dlmw.swisssignchallenge.repositories.SigningRequestDocumentRepository;
import ch.dlmw.swisssignchallenge.services.SigningRequestDocumentService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.UUID;

@Service
@AllArgsConstructor
public class SigningRequestDocumentServiceImpl implements SigningRequestDocumentService {
    private final SigningRequestDocumentRepository signingRequestDocumentRepository;

    @Override
    public void updateSigningRequestDocument(SigningRequestDocument signingRequestDocument) {
        var document = signingRequestDocumentRepository.findById(signingRequestDocument.getId()).orElseThrow();
        signingRequestDocument.setSigningRequest(document.getSigningRequest()); // todo: this is a bit ugly.. due to recursion the relationship is ignored so I set it manually
        signingRequestDocumentRepository.save(signingRequestDocument);
    }

    @Override
    public SigningRequestDocument getSigningRequestDocument(String id) {
        return signingRequestDocumentRepository.findById(UUID.fromString(id)).orElseThrow();
    }
}
